// SPDX-FileCopyrightText: Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
// SPDX-License-Identifier: BSD-3-Clause
#include "Basis_HGrad_HexC2Gradient.h"

const char *Basis_HGrad_HexC2Gradient =
"basisGradient[0 * 3 + 0] = (-0.125 + 0.25 * rr) * (-1. + ss) * ss * (-1. + tt) * tt;\n"
"basisGradient[0 * 3 + 1] = (-1. + rr) * rr * (-0.125 + 0.25 * ss) * (-1. + tt) * tt;\n"
"basisGradient[0 * 3 + 2] = (-1. + rr) * rr * (-1. + ss) * ss * (-0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[1 * 3 + 0] = (0.125 + 0.25 * rr) * (-1. + ss) * ss * (-1. + tt) * tt;\n"
"basisGradient[1 * 3 + 1] = rr * (1. + rr) * (-0.125 + 0.25 * ss) * (-1. + tt) * tt;\n"
"basisGradient[1 * 3 + 2] = rr * (1. + rr) * (-1. + ss) * ss * (-0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[2 * 3 + 0] = (0.125 + 0.25 * rr) * ss * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[2 * 3 + 1] = rr * (1. + rr) * (0.125 + 0.25 * ss) * (-1. + tt) * tt;\n"
"basisGradient[2 * 3 + 2] = rr * (1. + rr) * ss * (1. + ss) * (-0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[3 * 3 + 0] = (-0.125 + 0.25 * rr) * ss * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[3 * 3 + 1] = (-1. + rr) * rr * (0.125 + 0.25 * ss) * (-1. + tt) * tt;\n"
"basisGradient[3 * 3 + 2] = (-1. + rr) * rr * ss * (1. + ss) * (-0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[4 * 3 + 0] = (-0.125 + 0.25 * rr) * (-1. + ss) * ss * tt * (1. + tt);\n"
"basisGradient[4 * 3 + 1] = (-1. + rr) * rr * (-0.125 + 0.25 * ss) * tt * (1. + tt);\n"
"basisGradient[4 * 3 + 2] = (-1. + rr) * rr * (-1. + ss) * ss * (0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[5 * 3 + 0] = (0.125 + 0.25 * rr) * (-1. + ss) * ss * tt * (1. + tt);\n"
"basisGradient[5 * 3 + 1] = rr * (1. + rr) * (-0.125 + 0.25 * ss) * tt * (1. + tt);\n"
"basisGradient[5 * 3 + 2] = rr * (1. + rr) * (-1. + ss) * ss * (0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[6 * 3 + 0] = (0.125 + 0.25 * rr) * ss * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[6 * 3 + 1] = rr * (1. + rr) * (0.125 + 0.25 * ss) * tt * (1. + tt);\n"
"basisGradient[6 * 3 + 2] = rr * (1. + rr) * ss * (1. + ss) * (0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[7 * 3 + 0] = (-0.125 + 0.25 * rr) * ss * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[7 * 3 + 1] = (-1. + rr) * rr * (0.125 + 0.25 * ss) * tt * (1. + tt);\n"
"basisGradient[7 * 3 + 2] = (-1. + rr) * rr * ss * (1. + ss) * (0.125 + 0.25 * tt);\n"
"\n"
"basisGradient[8 * 3 + 0] = -0.5 * rr * (-1. + ss) * ss * (-1. + tt) * tt;\n"
"basisGradient[8 * 3 + 1] = (1. - rr) * (1. + rr) * (-0.25 + 0.5 * ss) * (-1. + tt) * tt;\n"
"basisGradient[8 * 3 + 2] = (1. - rr) * (1. + rr) * (-1. + ss) * ss * (-0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[9 * 3 + 0] = (0.25 + 0.5 * rr) * (1. - ss) * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[9 * 3 + 1] = rr * (1. + rr) * (-0.5 * ss) * (-1. + tt) * tt;\n"
"basisGradient[9 * 3 + 2] = rr * (1. + rr) * (1. - ss) * (1. + ss) * (-0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[10 * 3 + 0] = -0.5 * rr * ss * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[10 * 3 + 1] = (1. - rr) * (1. + rr) * (0.25 + 0.5 * ss) * (-1. + tt) * tt;\n"
"basisGradient[10 * 3 + 2] = (1. - rr) * (1. + rr) * ss * (1. + ss) * (-0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[11 * 3 + 0] = (-0.25 + 0.5 * rr) * (1. - ss) * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[11 * 3 + 1] = (-1. + rr) * rr * (-0.5 * ss) * (-1. + tt) * tt;\n"
"basisGradient[11 * 3 + 2] = (-1. + rr) * rr * (1. - ss) * (1. + ss) * (-0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[12 * 3 + 0] = (-0.25 + 0.5 * rr) * (-1. + ss) * ss * (1. - tt) * (1. + tt);\n"
"basisGradient[12 * 3 + 1] = (-1. + rr) * rr * (-0.25 + 0.5 * ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[12 * 3 + 2] = (-1. + rr) * rr * (-1. + ss) * ss * (-0.5 * tt);\n"
"\n"
"basisGradient[13 * 3 + 0] = (0.25 + 0.5 * rr) * (-1. + ss) * ss * (1. - tt) * (1. + tt);\n"
"basisGradient[13 * 3 + 1] = rr * (1. + rr) * (-0.25 + 0.5 * ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[13 * 3 + 2] = rr * (1. + rr) * (-1. + ss) * ss * (-0.5 * tt);\n"
"\n"
"basisGradient[14 * 3 + 0] = (0.25 + 0.5 * rr) * ss * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[14 * 3 + 1] = rr * (1. + rr) * (0.25 + 0.5 * ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[14 * 3 + 2] = rr * (1. + rr) * ss * (1. + ss) * (-0.5 * tt);\n"
"\n"
"basisGradient[15 * 3 + 0] = (-0.25 + 0.5 * rr) * ss * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[15 * 3 + 1] = (-1. + rr) * rr * (0.25 + 0.5 * ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[15 * 3 + 2] = (-1. + rr) * rr * ss * (1. + ss) * (-0.5 * tt);\n"
"\n"
"basisGradient[16 * 3 + 0] = -0.5 * rr * (-1. + ss) * ss * tt * (1. + tt);\n"
"basisGradient[16 * 3 + 1] = (1. - rr) * (1. + rr) * (-0.25 + 0.5 * ss) * tt * (1. + tt);\n"
"basisGradient[16 * 3 + 2] = (1. - rr) * (1. + rr) * (-1. + ss) * ss * (0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[17 * 3 + 0] = (0.25 + 0.5 * rr) * (1. - ss) * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[17 * 3 + 1] = rr * (1. + rr) * (-0.5 * ss) * tt * (1. + tt);\n"
"basisGradient[17 * 3 + 2] = rr * (1. + rr) * (1. - ss) * (1. + ss) * (0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[18 * 3 + 0] = -0.5 * rr * ss * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[18 * 3 + 1] = (1. - rr) * (1. + rr) * (0.25 + 0.5 * ss) * tt * (1. + tt);\n"
"basisGradient[18 * 3 + 2] = (1. - rr) * (1. + rr) * ss * (1. + ss) * (0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[19 * 3 + 0] = (-0.25 + 0.5 * rr) * (1. - ss) * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[19 * 3 + 1] = (-1. + rr) * rr * (-0.5 * ss) * tt * (1. + tt);\n"
"basisGradient[19 * 3 + 2] = (-1. + rr) * rr * (1. - ss) * (1. + ss) * (0.25 + 0.5 * tt);\n"
"\n"
"basisGradient[20 * 3 + 0] = -2. * rr * (1. - ss) * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[20 * 3 + 1] = (1. - rr) * (1. + rr) * (-2. * ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[20 * 3 + 2] = (1. - rr) * (1. + rr) * (1. - ss) * (1. + ss) * (-2. * tt);\n"
"\n"
"basisGradient[21 * 3 + 0] = -rr * (1. - ss) * (1. + ss) * (-1. + tt) * tt;\n"
"basisGradient[21 * 3 + 1] = (1. - rr) * (1. + rr) * (-ss) * (-1. + tt) * tt;\n"
"basisGradient[21 * 3 + 2] = (1. - rr) * (1. + rr) * (1. - ss) * (1. + ss) * (-0.5 + tt);\n"
"\n"
"basisGradient[22 * 3 + 0] = -rr * (1. - ss) * (1. + ss) * tt * (1. + tt);\n"
"basisGradient[22 * 3 + 1] = (1. - rr) * (1. + rr) * (-ss) * tt * (1. + tt);\n"
"basisGradient[22 * 3 + 2] = (1. - rr) * (1. + rr) * (1. - ss) * (1. + ss) * (0.5 + tt);\n"
"\n"
"basisGradient[23 * 3 + 0] = (-0.5 + rr) * (1. - ss) * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[23 * 3 + 1] = (-1. + rr) * rr * (-ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[23 * 3 + 2] = (-1. + rr) * rr * (1. - ss) * (1. + ss) * (-tt);\n"
"\n"
"basisGradient[24 * 3 + 0] = (0.5 + rr) * (1. - ss) * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[24 * 3 + 1] = rr * (1. + rr) * (-ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[24 * 3 + 2] = rr * (1. + rr) * (1. - ss) * (1. + ss) * (-tt);\n"
"\n"
"basisGradient[25 * 3 + 0] = -rr * (-1. + ss) * ss * (1. - tt) * (1. + tt);\n"
"basisGradient[25 * 3 + 1] = (1. - rr) * (1. + rr) * (-0.5 + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[25 * 3 + 2] = (1. - rr) * (1. + rr) * (-1. + ss) * ss * (-tt);\n"
"\n"
"basisGradient[26 * 3 + 0] = -rr * ss * (1. + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[26 * 3 + 1] = (1. - rr) * (1. + rr) * (0.5 + ss) * (1. - tt) * (1. + tt);\n"
"basisGradient[26 * 3 + 2] = (1. - rr) * (1. + rr) * ss * (1. + ss) * (-tt);\n"
"";
