// java wrapper for vtkIndexedLongArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkIndexedLongArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkIndexedLongArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkIndexedLongArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIndexedLongArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIndexedLongArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIndexedLongArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIndexedLongArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIndexedLongArray_ExtendedNew_14(JNIEnv* env, jobject obj)
{
  vtkIndexedLongArray * temp20;

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ExtendedNew();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIndexedLongArray_GetDataType_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIndexedLongArray_GetValue_16(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long   temp20;
  temp0 = id0;

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkIndexedLongArray_GetValueRange_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long * temp20;
  temp0 = id0;

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkIndexedLongArray_GetValueRange_18(JNIEnv* env, jobject obj)
{
  long * temp20;

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange();
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIndexedLongArray_FastDownCast_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  vtkIndexedLongArray * temp20;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FastDownCast(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIndexedLongArray_ConstructBackend_110(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkIdList * temp0;
  vtkDataArray * temp1;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ConstructBackend(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIndexedLongArray_ConstructBackend_111(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkDataArray * temp0;
  vtkDataArray * temp1;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkIndexedLongArray* op = static_cast<vtkIndexedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ConstructBackend(temp0,temp1);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkIndexedLongArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkIndexedLongArray::New());
}
