// java wrapper for vtkForEach object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkForEach.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataObjectAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkForEach_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkForEach",dType)) { return me; }
  if ((res= vtkDataObjectAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkForEach_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkForEach_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkForEach_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkForEach_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkForEach_FOR_1EACH_1FILTER_14(JNIEnv* env, jobject obj)
{
  vtkInformationObjectBaseKey * temp20;

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FOR_EACH_FILTER();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkForEach_SetRange_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkExecutionRange * temp0;
  temp0 = static_cast<vtkExecutionRange*>(vtkJavaGetPointerFromObject(env, id0));

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRange(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkForEach_IsIterating_16(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsIterating();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkForEach_RegisterEndFor_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkEndFor * temp0;
  temp0 = static_cast<vtkEndFor*>(vtkJavaGetPointerFromObject(env, id0));

  vtkForEach* op = static_cast<vtkForEach*>(vtkJavaGetPointerFromObject(env, obj));
  op->RegisterEndFor(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkForEach_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkForEach::New());
}
