// java wrapper for vtkTableFFT object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkTableFFT.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkTableAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTableFFT_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTableFFT",dType)) { return me; }
  if ((res= vtkTableAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableFFT_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableFFT_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetCreateFrequencyColumn_14(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCreateFrequencyColumn();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetCreateFrequencyColumn_15(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCreateFrequencyColumn(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_CreateFrequencyColumnOn_16(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->CreateFrequencyColumnOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_CreateFrequencyColumnOff_17(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->CreateFrequencyColumnOff();

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTableFFT_GetDefaultSampleRate_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDefaultSampleRate();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetDefaultSampleRate_19(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDefaultSampleRate(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetWindowingFunction_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWindowingFunction();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetWindowingFunction_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowingFunction(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetReturnOnesided_112(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetReturnOnesided();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetReturnOnesided_113(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetReturnOnesided(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_ReturnOnesidedOn_114(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReturnOnesidedOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_ReturnOnesidedOff_115(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReturnOnesidedOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetAverageFft_116(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAverageFft();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetAverageFft_117(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAverageFft(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_AverageFftOn_118(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->AverageFftOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_AverageFftOff_119(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->AverageFftOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetNormalize_120(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNormalize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetNormalize_121(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNormalize(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_NormalizeOn_122(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->NormalizeOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_NormalizeOff_123(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->NormalizeOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetBlockSize_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBlockSize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetBlockSize_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBlockSize(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetBlockOverlap_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBlockOverlap();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetBlockOverlap_127(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBlockOverlap(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetScalingMethod_128(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalingMethod();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetScalingMethod_129(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalingMethod(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetScalingMethodMinValue_130(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalingMethodMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetScalingMethodMaxValue_131(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalingMethodMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetDetrend_132(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDetrend();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetDetrend_133(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDetrend(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_DetrendOn_134(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->DetrendOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_DetrendOff_135(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->DetrendOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTableFFT_GetOptimizeForRealInput_136(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOptimizeForRealInput();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetOptimizeForRealInput_137(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOptimizeForRealInput(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_OptimizeForRealInputOn_138(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->OptimizeForRealInputOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_OptimizeForRealInputOff_139(JNIEnv* env, jobject obj)
{

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->OptimizeForRealInputOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableFFT_GetNumberOfBlock_140(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfBlock();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableFFT_SetNumberOfBlock_141(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableFFT* op = static_cast<vtkTableFFT*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfBlock(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTableFFT_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTableFFT::New());
}
