// java wrapper for vtkGoldenBallSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkGoldenBallSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkUnstructuredGridAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkGoldenBallSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkGoldenBallSource",dType)) { return me; }
  if ((res= vtkUnstructuredGridAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGoldenBallSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGoldenBallSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetRadius_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGoldenBallSource_GetRadiusMinValue_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGoldenBallSource_GetRadiusMaxValue_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGoldenBallSource_GetRadius_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadius();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetCenter_18(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetCenter_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkGoldenBallSource_GetCenter_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetResolution_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetResolution(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetResolutionMinValue_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetResolutionMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetResolutionMaxValue_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetResolutionMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetResolution_114(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetResolution();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetIncludeCenterPoint_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIncludeCenterPoint(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetIncludeCenterPoint_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIncludeCenterPoint();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_IncludeCenterPointOn_117(JNIEnv* env, jobject obj)
{

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->IncludeCenterPointOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_IncludeCenterPointOff_118(JNIEnv* env, jobject obj)
{

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->IncludeCenterPointOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetGenerateNormals_119(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGenerateNormals(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetGenerateNormals_120(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGenerateNormals();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_GenerateNormalsOn_121(JNIEnv* env, jobject obj)
{

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->GenerateNormalsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_GenerateNormalsOff_122(JNIEnv* env, jobject obj)
{

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->GenerateNormalsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGoldenBallSource_SetOutputPointsPrecision_123(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputPointsPrecision(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGoldenBallSource_GetOutputPointsPrecision_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGoldenBallSource* op = static_cast<vtkGoldenBallSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputPointsPrecision();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkGoldenBallSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkGoldenBallSource::New());
}
