// java wrapper for vtkCellGridWriter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkCellGridWriter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkWriter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellGridWriter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellGridWriter",dType)) { return me; }
  if ((res= vtkWriter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridWriter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridWriter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridWriter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridWriter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridWriter_SetFileName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCellGridWriter_GetFileName_15(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridWriter_GetInput_16(JNIEnv* env, jobject obj)
{
  vtkCellGrid * temp20;

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellGridWriter_GetInput_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkCellGrid * temp20;
  temp0 = id0;

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellGridWriter_SetFileFormat_18(JNIEnv* env, jobject obj,jint id0)
{
  vtkCellGridWriter::Format   temp0;
  temp0 = static_cast<vtkCellGridWriter::Format>(id0);

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileFormat(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellGridWriter_GetFileFormat_19(JNIEnv* env, jobject obj)
{
  vtkCellGridWriter::Format   temp20;

  vtkCellGridWriter* op = static_cast<vtkCellGridWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileFormat();
  return static_cast<jint>(temp20);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellGridWriter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellGridWriter::New());
}
