// java wrapper for vtkERFReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkERFReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPartitionedDataSetCollectionAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkERFReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkERFReader",dType)) { return me; }
  if ((res= vtkPartitionedDataSetCollectionAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkERFReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkERFReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkERFReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkERFReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_SetFileName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  std::string   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkERFReader_GetFileName_15(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkERFReader_GetStagesSelection_16(JNIEnv* env, jobject obj)
{
  vtkDataArraySelection * temp20;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStagesSelection();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkERFReader_GetVariablesSelection_17(JNIEnv* env, jobject obj)
{
  vtkDataArraySelection * temp20;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVariablesSelection();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkERFReader_GetBlocksSelection_18(JNIEnv* env, jobject obj)
{
  vtkDataArraySelection * temp20;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBlocksSelection();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_EnableAllVariables_19(JNIEnv* env, jobject obj)
{

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->EnableAllVariables();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_EnableAllBlocks_110(JNIEnv* env, jobject obj)
{

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->EnableAllBlocks();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_SetVariablesStatus_111(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jint id1)
{
  char * temp0;
  int   temp1;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = id1;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVariablesStatus(temp0,temp1);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_SetStagesStatus_112(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jint id1)
{
  char * temp0;
  int   temp1;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = id1;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStagesStatus(temp0,temp1);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkERFReader_SetBlocksStatus_113(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jint id1)
{
  char * temp0;
  int   temp1;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = id1;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBlocksStatus(temp0,temp1);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkERFReader_GetStage_114(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkERFReader* op = static_cast<vtkERFReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStage();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkERFReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkERFReader::New());
}
