// java wrapper for vtkIOSSCellGridReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkIOSSCellGridReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkIOSSReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkIOSSCellGridReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkIOSSCellGridReader",dType)) { return me; }
  if ((res= vtkIOSSReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIOSSCellGridReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIOSSCellGridReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_ReadMetaData_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  int   temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMetaData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_ReadMesh_15(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMesh(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_ReadPoints_16(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadPoints(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIOSSCellGridReader_ReadArrays_17(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkIOSSCellGridReader* op = static_cast<vtkIOSSCellGridReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadArrays(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkIOSSCellGridReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkIOSSCellGridReader::New());
}
