// java wrapper for vtkOpenGLBatchedPolyDataMapper object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkABI.h"
#include "vtkSystemIncludes.h"
#include "vtkOpenGLBatchedPolyDataMapper.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkOpenGLPolyDataMapper_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkOpenGLBatchedPolyDataMapper_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkOpenGLBatchedPolyDataMapper",dType)) { return me; }
  if ((res= vtkOpenGLPolyDataMapper_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_ClearBatchElements_14(JNIEnv* env, jobject obj)
{

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearBatchElements();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_SetParent_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCompositePolyDataMapper * temp0;
  temp0 = static_cast<vtkCompositePolyDataMapper*>(vtkJavaGetPointerFromObject(env, id0));

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetParent(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_RenderPiece_16(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkRenderer * temp0;
  vtkActor * temp1;
  temp0 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, id1));

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->RenderPiece(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_UnmarkBatchElements_17(JNIEnv* env, jobject obj)
{

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->UnmarkBatchElements();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_ClearUnmarkedBatchElements_18(JNIEnv* env, jobject obj)
{

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearUnmarkedBatchElements();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_GetMTime_19(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkOpenGLBatchedPolyDataMapper* op = static_cast<vtkOpenGLBatchedPolyDataMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkOpenGLBatchedPolyDataMapper_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkOpenGLBatchedPolyDataMapper::New());
}
